/*
 * Copyright (c) 2013, Institute of Electronics and Computer Science
 * All rights reserved.
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions are met:
 *  * Redistributions of source code must retain the above copyright notice,
 *    this list of  conditions and the following disclaimer.
 *  * Redistributions in binary form must reproduce the above copyright
 *    notice, this list of conditions and the following disclaimer in the
 *    documentation and/or other materials provided with the distribution.
 * THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS"
 * AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
 * IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
 * ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT HOLDER OR CONTRIBUTORS OR
 * CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL,
 * EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO,
 * PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS;
 * OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY,
 * WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR
 * OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF
 * ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
 *
 * cc1101_pins.h -- CC1101 radio hardware configuration
 */

#ifndef _CC1101_PINS_H_
#define _CC1101_PINS_H_

#define CC1101_SPI_ID    1

// Chip select pin
#define CC1101_CSN_PORT  3
#define CC1101_CSN_PIN   0

// SPI SI pin
#define CC1101_SI_PORT   3
#define CC1101_SI_PIN    1

// SPI SO pin
#define CC1101_SO_PORT   3
#define CC1101_SO_PIN    2

// SPI CLK pin
#define CC1101_CLK_PORT  3
#define CC1101_CLK_PIN   3

// Number of the GDO pin used for receive interrupts
#define CC1101_GDO_INTR  0

// The same pin on the MCU side
#define CC1101_INTR_PORT 1
#define CC1101_INTR_PIN  2

#endif // _CC1101_PINS_H_
